#ifndef __FOXFUNC_H_INCLUDE
#define __FOXFUNC_H_INCLUDE

/*
///////////////////////////////////////////////////////////////////////////
ɺʦCԽӿڡչýӿڹ淶V3.0
1.淶ڷɺʦV3.xʽϵͳ.
2.չʵϵͳʽʵֵ㷨.
3.չwindows 32λ̬ӿʵ,ʹMicrosoft Visual C++.
4.ʱڹʽ༭д"̬@"(),溯дΪ"FOXFUNC@MYMACLOSE"(5)
5.̬ӿƺͺƿԼ.
6.ʹʱ뽫̬ļڷɺʦװĿ¼µFmlDLLĿ¼ʹ.
*/

#ifdef __cplusplus
extern "C"
{
#endif //__cplusplus

////////////////////////////////////////////////////
//
////////////////////////////////////////////////////
enum DATA_TYPE
{
	TICK_DATA=2,				//ֱʳɽ
	MIN1_DATA,					//1
	MIN5_DATA,					//5					
	MIN15_DATA,					//15
	MIN30_DATA,					//30
	MIN60_DATA,					//60
	DAY_DATA,					//
	WEEK_DATA,					//
	MONTH_DATA,					//
	YEAR_DATA,					//
	MULTIDAY_DATA,				//
	MULTIMIN_DATA,				//
	MULTISEC_DATA				//
};

////////////////////////////////////////////////////
//
////////////////////////////////////////////////////

typedef struct tagSTKDATA	
{
	time_t	m_time;			//ʱ,UCT
	float	m_fOpen;		//
	float	m_fHigh;		//
	float	m_fLow;			//
	float	m_fClose;		//
	float	m_fVolume;		//ɽ()
	float	m_fAmount;		//ɽ(Ԫ)/ֲ(δƽֺԼڻЧ)
	WORD	m_wAdvance;		//Ǽ(Ч)
	WORD	m_wDecline;		//µ(Ч)
} STKDATA;

////////////////////////////////////////////////////
//չ,ֱʳɽݵ
////////////////////////////////////////////////////

typedef union tagSTKDATAEx
{
	struct
	{
		float m_fBuyPrice[3];		//1--3
		float m_fBuyVol[3];			//1--3
		float m_fSellPrice[3];		//1--3	
		float m_fSellVol[3];		//1--3
		DWORD m_dwToken;			//ɽ
	};
	float m_fDataEx[13];
} STKDATAEx;

////////////////////////////////////////////////////
//Ȩ
////////////////////////////////////////////////////

typedef struct tagSPLITDATA	
{
	time_t	m_time;			//ʱ,UCT
	float	m_fHg;			//
	float	m_fPg;			//
	float	m_fPgj;			//ɼ
	float	m_fHl;			//
} SPLITDATA;


////////////////////////////////////////////////////
/*˳(m_pfFinData)

		
	0	
	1	ܹɱ(),
	2	ҹ,
	3	˷˹,
	4	˹,
	5	B,
	6	H,
	7	ͨA,
	8	ְ,
	9	A2ת,
	10	ʲ(ǧԪ),
	11	ʲ,
	12	̶ʲ,
	13	ʲ,
	14	Ͷ,
	15	ծ,
	16	ڸծ,
	17	ʱ,
	18	ÿɹ,
	19	ɶȨ,
	20	Ӫ,
	21	Ӫ,
	22	,
	23	Ӫҵ,
	24	Ͷ,
	25	,
	26	Ӫҵ֧,
	27	,
	28	ܶ,
	29	˰,
	30	,
	31	δ,
	32	ÿδ,
	33	ÿ,
	34	ÿɾʲ,
	35	ÿɾ,
	36	ɶȨ,
	37	
	38  Ӫֽ
	39  Ӫֽ
	40  Ӫֽ
	41  Ͷֽ
	42  Ͷֽ
	43  Ͷֽ
	44  ֽ
	45  ֽ
	46  ֽ
	47  ֽ𼰵ȼ
	48  Ӧʿת
	49  ת
	50  ɶ
	51  м
	52  ٶ
	53  Ӫҵ
	54  ˰
	55  ʲ
	56  ʲ
*/

////////////////////////////////////////////////////
//òṹ
////////////////////////////////////////////////////
typedef struct tagCALCPARAM
{
	union 
	{
		const float*	m_pfParam;				//вָһ	
		const float		m_fParam;				//ֵ	
	};
	const int			m_nParamStart;			//вЧʼλ
}CALCPARAM;


////////////////////////////////////////////////////
//ýӿϢݽṹ
////////////////////////////////////////////////////
typedef struct tagCALCINFO
{
	const DWORD			m_dwSize;				//ṹС
	const DWORD			m_dwVersion;			//汾(V3.00 : 0x300)
	const DWORD			m_dwSerial;				//к
	const char*			m_strStkLabel;			//Ʊ
	const BOOL			m_bIndex;				//

	const int			m_nNumData;				//(pData,pDataEx,pResultBuf)
	const STKDATA*		m_pData;				//,ע:m_nNumData==0ʱΪ NULL
	const STKDATAEx*	m_pDataEx;				//չ,ֱʳɽ,ע:Ϊ NULL

	const int			m_nParam1Start;			//1Чʼλ
	const float*		m_pfParam1;				//ò1	
	const float*		m_pfParam2;				//ò2
	const float*		m_pfParam3;				//ò3
	const float*		m_pfParam4;				//ò4

	float*				m_pResultBuf;			//
	const DWORD			m_dataType;				//
	const float*		m_pfFinData;			//

//Ҽݣṹ

//Ϊɺʦչ

	const DWORD			m_dwReserved;			// 

	const int			m_nNumParam;			// ò
	const CALCPARAM*	m_pCalcParam;			// ò

	const DWORD			m_dwReservedEx[4];		// 

	char*				m_strStkName;			//Ʊ

	SPLITDATA*			m_pSplitData;			//Ȩ
	int					m_nNumSplitData;		//Ȩ

} CALCINFO;

/* 
ע1: (Ҽ)
	1.òm_pfParam1--m_pfParam4,ΪNULLʾòЧ.
	2.һЧʱ,вЧ.
		:m_pfParam2ΪNULL,m_pfParam3,m_pfParam4ҲΪNULL.
	3.1ǳ,ֻΪ.
	4.m_nParam1Start<0, 1Ϊ,*m_pfParam1;
	5.m_nParam1Start>=0,1Ϊ,m_pfParam1ָһ,
		СΪm_nNumData,ЧΧΪ m_nParam1Start  m_nNumData-1.
		ʱm_pData[x]  m_pfParam1[x]һµ

ע2: (ɺʦչ)
	1.չṹʹòڼϿĿģÿΪֵУɹʽʵʵĵò
	2.CALCPARAMṹڴϢʵݣm_pCalcParamСΪm_nNumParamЧΧΪ 0  m_nNumParam-1.
	3.˳m_pCalcParam[0]Ϊһݣm_pCalcParam[1]Ϊڶ...Ϊ˱ּݣԭm_nParam1Startm_pfParam15Ȼиֵ
	4. iλõĲΪֵȡm_pCalcParam[i].m_fParam.
	5. iλõĲΪУȡm_pCalcParam[i].m_pfParamСΪm_nNumData,ЧΧΪm_pCalcParam[i].m_nParamStart  m_nNumData-1. m_pCalcParam[i].m_nParamStart<0, Чݡ
	6.ڿԵöУеļڹʽнУȻΪõĲɡ
	7.չԷҵDLLȻԵáݡ

*/


////////////////////////////////////////////////////
/* 

__declspec(dllexport) int xxxxxxxx(CALCINFO* pData);

1.ȫд.
2.ʽ,ʵʺxxxxxxxx;
	C++ extern "C" {   } .
3.pData->m_pResultBuf.
4.-1ʾȫЧ,򷵻صһЧֵλ,:
	m_pResultBuf[ֵ] -- m_pResultBuf[m_nNumData-1]ΪЧֵ.
5.ƳȲܳ15ֽ,̬ӿļܳ9ֽ(չ),̬ƲܽSYSTEM,EXPLORER

*/

//ʾ,ʹʱʵ滻
__declspec(dllexport) int WINAPI MYMACLOSE(CALCINFO* pData);
__declspec(dllexport) int WINAPI MYMAVAR(CALCINFO* pData);
__declspec(dllexport) int WINAPI MYBBI(CALCINFO* pData);

#ifdef __cplusplus
}
#endif //__cplusplus


#endif //__FOXFUNC_H_INCLUDE
